//import javax.swing.*;
import java.awt.*;
import java.util.Vector;

public class RowBuffer extends java.awt.Panel {
  public RowBuffer(int n, boolean b) {

    nColumn = n;
    realBuffer = b;

    setLayout(new GridLayout(1, nColumn, 2, 2));

    Label tmpLabel1 = new Label("      ");
    add(tmpLabel1);

    for ( int i = 0 ; i < nColumn ; i++ ) {
      MatrixButton topButton = new MatrixButton();
      if ( realBuffer ) {
	topButton.setBackground(Color.cyan);
      }
      else {
	topButton.setBackground(Color.yellow);
      }
      add(topButton);
    }

    Label tmpLabel2 = new Label("      ");
    add(tmpLabel2);

    /**
    setLayout(new BorderLayout());
    MatrixButton topButton = new MatrixButton("12.34");
    topButton.setBackground(Color.red);
    add("Center", topButton);

    MatrixButton dummyButton1 = new MatrixButton("");
    dummyButton1.setBackground(Color.yellow);
    add("East", dummyButton1);

    MatrixButton dummyButton2 = new MatrixButton("");
    dummyButton2.setBackground(Color.yellow);
    add("West", dummyButton2);
    **/

  }

  public RowBuffer(int n, int _startIndex, int _endIndex, boolean b, Color _colorBackground, Color _colorBuffer ) {

    nColumn = n;

    startIndex = _startIndex;
    endIndex = _endIndex;

    realBuffer = b;

    colorBackground   = _colorBackground;
    colorBuffer     = _colorBuffer;

    setLayout(new GridLayout(1, nColumn, 2, 2));

    Label tmpLabel1 = new Label("      ");
    add(tmpLabel1);

    for ( int i = 0 ; i < startIndex ; i++ ) {
      MatrixButton topButton = new MatrixButton();
      topButton.setBackground(colorBackground);
      topButton.setForeground(colorBackground);
      add(topButton);
      rowBufferItem.addElement(topButton);
    }
    for ( int i = startIndex ; i < endIndex ; i++ ) {
      MatrixButton topButton = new MatrixButton();
      if ( realBuffer ) {
	topButton.setBackground(colorBuffer);
      }
      else {
	topButton.setBackground(colorBackground);
	topButton.setForeground(colorBackground);
      }
      add(topButton);
      rowBufferItem.addElement(topButton);
    }

    for ( int i = endIndex ; i < nColumn ; i++ ) {
      MatrixButton topButton = new MatrixButton();
      topButton.setBackground(colorBackground);
      topButton.setForeground(colorBackground);
      add(topButton);
      rowBufferItem.addElement(topButton);
    } 

    Label tmpLabel2 = new Label("      ");
    add(tmpLabel2);

  }

  /**
  // method       : setTopBackground
  // functionality: sets the background color of the upper 
  //                part of the square
  public void setTopBackground(Color color) {
    topButton.setBackground(color);
  }

  // method       : getTopBackground
  // functionality: returns the background color of the upper 
  //                part of the square
  public Color getTopBackground() {
    return topButton.getBackground();
  }

  // method       : setTopForeground
  // functionality: sets the foreground color of the upper 
  //                part of the square	
  public void setTopForeground(Color color) {
    topButton.setForeground(color);
  }

  // method       : getTopForeground
  // functionality: returns the foreground color of the upper
  //                part of the square
  public Color getTopForeground() {
    return topButton.getForeground();
  }
  **/

  // method       : setText
  // functionality: sets the text to be display in the upper 
  //                part of the square
  public void setText(Vector texts) {
    for ( int i = 0 ; i < rowBufferItem.size() ; i++ ) {
      ((MatrixButton)rowBufferItem.elementAt(i)).setText((String)texts.elementAt(i));
    }
  }

  public void updateColor() {
    for ( int i = startIndex ; i < endIndex ; i++ ) {
      if ( realBuffer ) {
	((MatrixButton)rowBufferItem.elementAt(i)).setBackground(Color.blue);
      }
    }
  }

  // method       : getText
  // functionality: returns the text to be display in the upper
  //                part of the square
  public String getText() {
    return "aa";
  }

  public void returnColor() {
    for ( int i = startIndex ; i < endIndex ; i++ ) {
      if ( realBuffer ) {
	((MatrixButton)rowBufferItem.elementAt(i)).setBackground(colorBuffer);
      }
      else {
	((MatrixButton)rowBufferItem.elementAt(i)).setBackground(colorBackground);
      }
    }
  }

  protected int nColumn = 0;
  protected int startIndex = 0;
  protected int endIndex = 0;

  protected boolean realBuffer = true;

  protected Vector rowBufferItem =  new Vector();

  protected Color colorBackground;
  protected Color colorBuffer;
  protected Color colorBufferUpdate;
}
